#include "uart.h"

u8 TX2_Cnt;     // ͼ
u8 RX2_Cnt;     // ռ
bit B_TX2_Busy; // æ־
bit B_RX2_OK;   // ɱ־

u8 xdata PARITYBIT = EVEN_PARITY;

u8 xdata RX2_Buffer[UART2_BUF_LENGTH]; // ջ

void SetTimer2Baudraye(u16 dat)
{
    AUXR &= ~(1 << 4); // Timer stop
    AUXR &= ~(1 << 3); // Timer2 set As Timer
    AUXR |= (1 << 2);  // Timer2 set as 1T mode
    T2H = dat / 256;
    T2L = dat % 256;
    IE2 &= ~(1 << 2); // ֹж
    AUXR |= (1 << 4); // Timer run enable
}

void UART2_config(u8 baudrate_list, u8 paritybit) // ѡ,У鷽ʽ
{
    switch (baudrate_list)
    {
    case baudrate_2400:
        SetTimer2Baudraye(65536UL - (MAIN_Fosc / 4) / 2400UL);
        break;
    case baudrate_4800:
        SetTimer2Baudraye(65536UL - (MAIN_Fosc / 4) / 4800UL);
        break;
    case baudrate_9600:
        SetTimer2Baudraye(65536UL - (MAIN_Fosc / 4) / 9600UL);
        break;
    case baudrate_19200:
        SetTimer2Baudraye(65536UL - (MAIN_Fosc / 4) / 19200UL);
        break;
    case baudrate_38400:
        SetTimer2Baudraye(65536UL - (MAIN_Fosc / 4) / 38400UL);
        break;
    case baudrate_57600:
        SetTimer2Baudraye(65536UL - (MAIN_Fosc / 4) / 57600UL);
        break;
    case baudrate_115200:
        SetTimer2Baudraye(65536UL - (MAIN_Fosc / 4) / 115200UL);
        break;
    case baudrate_128000:
        SetTimer2Baudraye(65536UL - (MAIN_Fosc / 4) / 128000UL);
        break;
    case baudrate_230400:
        SetTimer2Baudraye(65536UL - (MAIN_Fosc / 4) / 230400UL);
        break;
    case baudrate_256000:
        SetTimer2Baudraye(65536UL - (MAIN_Fosc / 4) / 256000UL);
        break;
    default:
        break;
    }

    S2CON &= ~(1 << 7); // 8λ, 1λʼλ, 1λֹͣλ, У
    IE2 |= 1;           // ж
    S2CON |= (1 << 4);  // 
    P_SW2 &= ~0x01;
    P_SW2 |= 0; // UART2 switch to: 0: P1.0 P1.1,  1: P4.6 P4.7
    PARITYBIT = paritybit;
    switch (paritybit)
    {
    case NONE_PARITY:
        USART2CR2 = 0x00; // ֹӲżУ
        break;
    case EVEN_PARITY:
        // 2(ģʽ1ɱ䲨9λ)
        S2CON |= 0x80;
        USART2CR2 = 0x04; // ʹӲżУ
        break;
    case ODD_PARITY:
        // 2(ģʽ1ɱ䲨9λ)
        S2CON |= 0x80;
        USART2CR2 = 0x06; // ʹӲУ
        break;
    default:
        break;
    }
    B_TX2_Busy = 0;
    TX2_Cnt = 0;
    RX2_Cnt = 0;
}

void Uart_Init(void)
{
    UART2_config(baudrate_115200, EVEN_PARITY); // ʹöʱ2Ϊʷ
}

void UART2_Isr(void) interrupt 8
{
    if ((S2CON & 1) != 0)
    {
        S2CON &= ~1; // Clear Rx flag
        if (S2BUF == 0x7f && STATE == 1)
        {
            Cnt7F++;
        }
        else
        {
            Cnt7F = 0;
        }
        B_RX2_OK = 1;
    }
    if ((S2CON & 2) != 0)
    {
        S2CON &= ~2; // Clear Tx flag
        B_TX2_Busy = 0;
    }
}

void UART2_TxByte(u8 dat)
{
    while (B_TX2_Busy)
        ;
    ACC = dat; // ȡУλP (PSW.0)
    if (P)     // PУλ
    {
        if (PARITYBIT == ODD_PARITY)
            S2CON &= ~S2TB8; // УλΪ0
        else if (PARITYBIT == EVEN_PARITY)
            S2CON |= S2TB8; // УλΪ1
    }
    else
    {
        if (PARITYBIT == ODD_PARITY)
            S2CON |= S2TB8; // УλΪ1
        else if (PARITYBIT == EVEN_PARITY)
            S2CON &= ~S2TB8; // УλΪ0
    }
    B_TX2_Busy = 1;
    S2BUF = dat;
}

void PrintString2(u8 *puts)
{
    for (; *puts != 0; puts++) // ֹͣ0
    {
        UART2_TxByte(*puts);
    }
}